#ifndef _HEADERS_FUNCTIONS_H
#define _HEADERS_FUNCTIONS_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool WaitOnApplicationToExit(void)
{
    gbKillApplication = true; // Tell application to exit

    if(gbIsClientDialogOpen)
    {
        EndDialog(MainDialog_hWnd, 0);
    }

    while(gbApplicationRunning) // Wait on application to exit
    {
        Sleep(1);
    }

    return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool xMainEntry(void)
{
    gbApplicationRunning = true;

    if(!Initialize())
    {
		MessageBox (NULL, "Failed to initialize!", TitleCaption, MB_ICONHAND | MB_SYSTEMMODAL);
		return false;
    }

	Timer_Thread_Handle = CreateThread(NULL, 0, Timer_Thread, (LPVOID)0, 0, &Timer_Thread_ID);

    while(!gbKillApplication)
    {
    	if(WaitForSingleObject(OpenESQLExgClientMainDialog_Handle, 0) == WAIT_OBJECT_0)
        {
            DialogBox(MainInstance, MAKEINTRESOURCE(IDD_MAIN), 0, MainDialog);
        }

        Sleep(1);
    }

    if(!Uninitialize())
    {
		MessageBox (NULL, "Failed to uninitialize!", TitleCaption, MB_ICONHAND | MB_SYSTEMMODAL);
		return false;
    }

    gbApplicationRunning = false;

    return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool ClientSend(char *String, int Length)
{
    while( !MyClient.SetSendDataEx(String, Length) && MyClient.Connected )
        Sleep(1);

    return MyClient.Connected;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool SimpleClientSend(char *Text)
{
    return ClientSend(Text, strlen(Text));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool DoConnect(void)
{

    return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool DoDisconnect(void)
{
    InsertListBoxItem(MDI.RecvEdit_hWnd, "Disconnected.", -1);

    return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool GetRegistryValues(void)
{
	DWORD SizeofString = 0;

    SizeofString = sizeof(gsSQLServer);
	memset(gsSQLServer, 0, SizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "SQLServer", gsSQLServer, SizeofString))
        return false;

    SizeofString = sizeof(gsSQLUserID);
	memset(gsSQLUserID, 0, SizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "SQLUserID", gsSQLUserID, SizeofString))
        return false;

    SizeofString = sizeof(gsSQLPassword);
	memset(gsSQLPassword, 0, SizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "SQLPassword", gsSQLPassword, SizeofString))
        return false;

    SizeofString = sizeof(gsSQLDriver);
	memset(gsSQLDriver, 0, SizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "SQLDriver", gsSQLDriver, SizeofString))
        return false;

    SizeofString = sizeof(gsSQLDatabase);
	memset(gsSQLDatabase, 0, SizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "SQLDatabase", gsSQLDatabase, SizeofString))
        return false;

    SizeofString = sizeof(gsWPServer);
	memset(gsWPServer, 0, SizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "WPServer", gsWPServer, SizeofString))
        return false;

    SizeofString = sizeof(gsBaseCommKey);
	memset(gsBaseCommKey, 0, SizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BaseCommKey", gsBaseCommKey, SizeofString))
        return false;

    SizeofString = sizeof(gsAuthString);
	memset(gsAuthString, 0, SizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "AuthString", gsAuthString, SizeofString))
        return false;

    SizeofString = sizeof(gsCompanyName);
	memset(gsCompanyName, 0, SizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "CompanyName", gsCompanyName, SizeofString))
        return false;

    SizeofString = sizeof(gsCompanyPassword);
	memset(gsCompanyPassword, 0, SizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "CompanyPassword", gsCompanyPassword, SizeofString))
        return false;

    SizeofString = sizeof(gsBaseCommKey);
	memset(gsBaseCommKey, 0, SizeofString);
    if(!Get_StringRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "BaseCommKey", gsBaseCommKey, SizeofString))
        return false;

	if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "TCPLoopDelay", glTCPLoopDelay))
        return false;

    if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "ConnectPort", glConnectPort))
        return false;

    if(!Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE, RegistryKey, "ConnectInterval", glConnectInterval))
        return false;

    return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

