////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool Initialize(void)
{
    InitCommonControls();

    InitializeCRCTable();

    if(!GetRegistryValues())
    {
		MessageBox(NULL, "Error getting registry values!", TitleCaption, MB_ICONHAND + MB_SYSTEMMODAL);
        return 0;
    }

    if(!InitCryptography())
    {
		MessageBox(NULL, "Error initializing cryptography!", TitleCaption, MB_ICONHAND + MB_SYSTEMMODAL);
        return 0;
    }

    if(!InitilizeQueu(&QS, 100))
    {
		MessageBox(NULL, "Error initilize queu!", TitleCaption, MB_ICONHAND + MB_SYSTEMMODAL);
        return 0;
    }

	if(!MyClient.Start())
    {
		MessageBox(NULL, "Error statting the client!", TitleCaption, MB_ICONHAND + MB_SYSTEMMODAL);
        return 0;
    }

    return true;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool Uninitialize(void)
{
    UninitCryptography();

	MyClient.Stop();

    return true;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

